// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// An on-premises file system Linked Service.
    /// </summary>
    public partial class OnPremisesFileSystemLinkedService : LinkedServiceProperties
    {
        private string _encryptedCredential;
        
        /// <summary>
        /// Optional. Encrypted credential which contains host, userId and
        /// password.
        /// </summary>
        public string EncryptedCredential
        {
            get { return this._encryptedCredential; }
            set { this._encryptedCredential = value; }
        }
        
        private string _gatewayName;
        
        /// <summary>
        /// Required. The on-premises gateway name.
        /// </summary>
        public string GatewayName
        {
            get { return this._gatewayName; }
            set { this._gatewayName = value; }
        }
        
        private string _host;
        
        /// <summary>
        /// Required. Host name of the server.
        /// </summary>
        public string Host
        {
            get { return this._host; }
            set { this._host = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Optional. Password to logon the server.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _userId;
        
        /// <summary>
        /// Optional. UserID to logon the server.
        /// </summary>
        public string UserId
        {
            get { return this._userId; }
            set { this._userId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesFileSystemLinkedService
        /// class.
        /// </summary>
        public OnPremisesFileSystemLinkedService()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesFileSystemLinkedService
        /// class with required arguments.
        /// </summary>
        public OnPremisesFileSystemLinkedService(string host, string gatewayName)
            : this()
        {
            if (host == null)
            {
                throw new ArgumentNullException("host");
            }
            if (gatewayName == null)
            {
                throw new ArgumentNullException("gatewayName");
            }
            this.Host = host;
            this.GatewayName = gatewayName;
        }
    }
}
