// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// An on-premises SQL server database.
    /// </summary>
    public partial class OnPremisesSqlLinkedService : LinkedServiceProperties
    {
        private string _connectionString;
        
        /// <summary>
        /// Required. The connection string.
        /// </summary>
        public string ConnectionString
        {
            get { return this._connectionString; }
            set { this._connectionString = value; }
        }
        
        private string _gatewayName;
        
        /// <summary>
        /// Required. The on-premises gateway name.
        /// </summary>
        public string GatewayName
        {
            get { return this._gatewayName; }
            set { this._gatewayName = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Optional. The on-premises Windows authentication password.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Optional. The on-premises Windows authentication user name.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesSqlLinkedService class.
        /// </summary>
        public OnPremisesSqlLinkedService()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesSqlLinkedService class
        /// with required arguments.
        /// </summary>
        public OnPremisesSqlLinkedService(string connectionString, string gatewayName)
            : this()
        {
            if (connectionString == null)
            {
                throw new ArgumentNullException("connectionString");
            }
            if (gatewayName == null)
            {
                throw new ArgumentNullException("gatewayName");
            }
            this.ConnectionString = connectionString;
            this.GatewayName = gatewayName;
        }
    }
}
