// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.Azure.Management.Insights;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights
{
    public static partial class AutoscaleOperationsExtensions
    {
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse CreateOrUpdateSetting(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName, AutoscaleSettingCreateOrUpdateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutoscaleOperations)s).CreateOrUpdateSettingAsync(resourceGroupName, autoscaleSettingName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> CreateOrUpdateSettingAsync(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName, AutoscaleSettingCreateOrUpdateParameters parameters)
        {
            return operations.CreateOrUpdateSettingAsync(resourceGroupName, autoscaleSettingName, parameters, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse DeleteSetting(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutoscaleOperations)s).DeleteSettingAsync(resourceGroupName, autoscaleSettingName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> DeleteSettingAsync(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName)
        {
            return operations.DeleteSettingAsync(resourceGroupName, autoscaleSettingName, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AutoscaleSettingGetResponse GetSetting(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutoscaleOperations)s).GetSettingAsync(resourceGroupName, autoscaleSettingName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AutoscaleSettingGetResponse> GetSettingAsync(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName)
        {
            return operations.GetSettingAsync(resourceGroupName, autoscaleSettingName, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='targetResourceUri'>
        /// Optional. The resource identifier of the target of the autoscale
        /// setting.
        /// </param>
        /// <returns>
        /// The List Autoscale settings operation response.
        /// </returns>
        public static AutoscaleSettingListResponse ListSettings(this IAutoscaleOperations operations, string resourceGroupName, string targetResourceUri)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutoscaleOperations)s).ListSettingsAsync(resourceGroupName, targetResourceUri);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='targetResourceUri'>
        /// Optional. The resource identifier of the target of the autoscale
        /// setting.
        /// </param>
        /// <returns>
        /// The List Autoscale settings operation response.
        /// </returns>
        public static Task<AutoscaleSettingListResponse> ListSettingsAsync(this IAutoscaleOperations operations, string resourceGroupName, string targetResourceUri)
        {
            return operations.ListSettingsAsync(resourceGroupName, targetResourceUri, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse UpdateSetting(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName, AutoscaleSettingCreateOrUpdateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutoscaleOperations)s).UpdateSettingAsync(resourceGroupName, autoscaleSettingName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutoscaleOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='autoscaleSettingName'>
        /// Required. The autoscale setting name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> UpdateSettingAsync(this IAutoscaleOperations operations, string resourceGroupName, string autoscaleSettingName, AutoscaleSettingCreateOrUpdateParameters parameters)
        {
            return operations.UpdateSettingAsync(resourceGroupName, autoscaleSettingName, parameters, CancellationToken.None);
        }
    }
}
