// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// Parameters for a Stream Analytics job get operation.
    /// </summary>
    public partial class JobGetParameters
    {
        private string _propertiesToExpand;
        
        /// <summary>
        /// Required. Gets or sets the properties to expand. Comma-separated
        /// list of additional properties to include in the response, beyond
        /// the default set returned when this parameter is absent. The
        /// default set is all properties other than “inputs”,
        /// “transformation”, and “outputs”.
        /// </summary>
        public string PropertiesToExpand
        {
            get { return this._propertiesToExpand; }
            set { this._propertiesToExpand = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobGetParameters class.
        /// </summary>
        public JobGetParameters()
        {
            this.PropertiesToExpand = "";
        }
        
        /// <summary>
        /// Initializes a new instance of the JobGetParameters class with
        /// required arguments.
        /// </summary>
        public JobGetParameters(string propertiesToExpand)
            : this()
        {
            if (propertiesToExpand == null)
            {
                throw new ArgumentNullException("propertiesToExpand");
            }
            this.PropertiesToExpand = propertiesToExpand;
        }
    }
}
