// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// A standard service response including an HTTP status code and request
    /// ID.
    /// </summary>
    public partial class ListRouteTablesResponse : AzureOperationResponse, IEnumerable<RouteTable>
    {
        private IList<RouteTable> _routeTables;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IList<RouteTable> RouteTables
        {
            get { return this._routeTables; }
            set { this._routeTables = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ListRouteTablesResponse class.
        /// </summary>
        public ListRouteTablesResponse()
        {
            this.RouteTables = new LazyList<RouteTable>();
        }
        
        /// <summary>
        /// Gets the sequence of RouteTables.
        /// </summary>
        public IEnumerator<RouteTable> GetEnumerator()
        {
            return this.RouteTables.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of RouteTables.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
