// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a Protection profile details.
    /// </summary>
    public partial class ProtectionProfileAssociationDetails
    {
        private string _associationStatus;
        
        /// <summary>
        /// Required. The association status.
        /// </summary>
        public string AssociationStatus
        {
            get { return this._associationStatus; }
            set { this._associationStatus = value; }
        }
        
        private string _primaryProtectionContainerId;
        
        /// <summary>
        /// Required. The PrimaryProtectionContainerId.
        /// </summary>
        public string PrimaryProtectionContainerId
        {
            get { return this._primaryProtectionContainerId; }
            set { this._primaryProtectionContainerId = value; }
        }
        
        private string _recoveryProtectionContainerId;
        
        /// <summary>
        /// Required. The Recovery Protection Container Id.
        /// </summary>
        public string RecoveryProtectionContainerId
        {
            get { return this._recoveryProtectionContainerId; }
            set { this._recoveryProtectionContainerId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ProtectionProfileAssociationDetails class.
        /// </summary>
        public ProtectionProfileAssociationDetails()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ProtectionProfileAssociationDetails class with required arguments.
        /// </summary>
        public ProtectionProfileAssociationDetails(string primaryProtectionContainerId, string recoveryProtectionContainerId, string associationStatus)
            : this()
        {
            if (primaryProtectionContainerId == null)
            {
                throw new ArgumentNullException("primaryProtectionContainerId");
            }
            if (recoveryProtectionContainerId == null)
            {
                throw new ArgumentNullException("recoveryProtectionContainerId");
            }
            if (associationStatus == null)
            {
                throw new ArgumentNullException("associationStatus");
            }
            this.PrimaryProtectionContainerId = primaryProtectionContainerId;
            this.RecoveryProtectionContainerId = recoveryProtectionContainerId;
            this.AssociationStatus = associationStatus;
        }
    }
}
