// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Awesome Info about Device
    /// </summary>
    public partial class SacChangeListResponse : IEnumerable<StorageAccountCredentialResponse>
    {
        private IList<StorageAccountCredentialResponse> _added;
        
        /// <summary>
        /// Optional. List of storage account credentials to add
        /// </summary>
        public IList<StorageAccountCredentialResponse> Added
        {
            get { return this._added; }
            set { this._added = value; }
        }
        
        private IList<string> _deleted;
        
        /// <summary>
        /// Optional. Deleted storage account credentials
        /// </summary>
        public IList<string> Deleted
        {
            get { return this._deleted; }
            set { this._deleted = value; }
        }
        
        private IList<StorageAccountCredentialResponse> _updated;
        
        /// <summary>
        /// Optional. List of storage account credentials to update
        /// </summary>
        public IList<StorageAccountCredentialResponse> Updated
        {
            get { return this._updated; }
            set { this._updated = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SacChangeListResponse class.
        /// </summary>
        public SacChangeListResponse()
        {
            this.Added = new List<StorageAccountCredentialResponse>();
            this.Deleted = new List<string>();
            this.Updated = new List<StorageAccountCredentialResponse>();
        }
        
        /// <summary>
        /// Gets the sequence of Added.
        /// </summary>
        public IEnumerator<StorageAccountCredentialResponse> GetEnumerator()
        {
            return this.Added.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Added.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
