// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Device WebProxy settings
    /// </summary>
    public partial class WebProxySettings
    {
        private AuthenticationType _authentication;
        
        /// <summary>
        /// Required. Gets or sets the Authentication
        /// </summary>
        public AuthenticationType Authentication
        {
            get { return this._authentication; }
            set { this._authentication = value; }
        }
        
        private string _connectionURI;
        
        /// <summary>
        /// Required. Gets or sets the Connection URI
        /// </summary>
        public string ConnectionURI
        {
            get { return this._connectionURI; }
            set { this._connectionURI = value; }
        }
        
        private string _username;
        
        /// <summary>
        /// Required. Gets or sets the Username
        /// </summary>
        public string Username
        {
            get { return this._username; }
            set { this._username = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WebProxySettings class.
        /// </summary>
        public WebProxySettings()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the WebProxySettings class with
        /// required arguments.
        /// </summary>
        public WebProxySettings(AuthenticationType authentication, string connectionURI, string username)
            : this()
        {
            if (connectionURI == null)
            {
                throw new ArgumentNullException("connectionURI");
            }
            if (username == null)
            {
                throw new ArgumentNullException("username");
            }
            this.Authentication = authentication;
            this.ConnectionURI = connectionURI;
            this.Username = username;
        }
    }
}
