// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.TrafficManager.Models;

namespace Microsoft.WindowsAzure.Management.TrafficManager.Models
{
    /// <summary>
    /// Describes a profile.
    /// </summary>
    public partial class Profile
    {
        private IList<DefinitionStatusAndVersion> _definitions;
        
        /// <summary>
        /// Optional. Specifies the definition for the specified profile, along
        /// with the status. Only one definition version exists for a profile.
        /// </summary>
        public IList<DefinitionStatusAndVersion> Definitions
        {
            get { return this._definitions; }
            set { this._definitions = value; }
        }
        
        private string _domainName;
        
        /// <summary>
        /// Optional. The domain name, as specified during the creation of the
        /// profile.
        /// </summary>
        public string DomainName
        {
            get { return this._domainName; }
            set { this._domainName = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. The profile name, as specified during the creation of the
        /// profile.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private ProfileDefinitionStatus _status;
        
        /// <summary>
        /// Optional. Indicates whether a definition of the specified profile
        /// is enabled or disabled in Windows Azure Traffic Manager.
        /// </summary>
        public ProfileDefinitionStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private ProfileStatusDetails _statusDetails;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public ProfileStatusDetails StatusDetails
        {
            get { return this._statusDetails; }
            set { this._statusDetails = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Profile class.
        /// </summary>
        public Profile()
        {
            this.Definitions = new LazyList<DefinitionStatusAndVersion>();
        }
    }
}
